/**
 * @author: mg12 [http://www.neoease.com/]
 * @update: 2012/11/05
 */

GoTop = function() {

	this.config = {
		pageWidth			:1200,		// e
		nodeId				:'go-top',	// Go Top `I ID
		nodeWidth			:50,		// Go Top `Ie
		distanceToBottom	:150,		// Go Top `IW쭶Z
		distanceToPage		:20,		// Go Top `I쭶VVkZ
		hideRegionHeight	:90,		// ø`Iϰ쪺(Ӱϰq}l)
		text				:''			// Go Top re
	};

	this.cache = {
		topLinkThread		:null		//  Go Top `Iu{ܶq (Ω IE6)
	}
};

GoTop.prototype = {

	init: function(config) {
		this.config = config || this.config;
		var _self = this;

		// uʫ̹, ק`ImMܪA
		jQuery(window).scroll(function() {
			_self._scrollScreen({_self:_self});
		});

		// ܫ̹ؤo, ק`Im
		jQuery(window).resize(function() {
			_self._resizeWindow({_self:_self});
		});

		// bJ`I点
		_self._insertNode({_self:_self});
	},

	/**
	 * bJ`I
	 */
	_insertNode: function(args) {
		var _self = args._self;

		// J`Iøjw`Iƥ, `IQI, 0.4 ɶuʨ쭶
		var topLink = jQuery('<a id="' + _self.config.nodeId + '" href="#">' + _self.config.text + '</a>');
		topLink.click(function() {
			jQuery('html,body').animate({scrollTop: 0}, 400);
			return false;
		}).appendTo(jQuery('body'));

		// `I̹k䪺Z
		//var right = _self._getDistanceToBottom({_self:_self});
        var right =180;
		// IE6 ( position:fi??xed) ˦
		if(/MSIE 6/i.test(navigator.userAgent)) {
			topLink.css({
				'display': 'none',
				'position': 'absolute',
				'right': right + 'px',
	//			'background-image':'url(../images/go_top.gif)',
		    	'background-image':'url(../images/go-top1.png)',
				'opacity':'0.6'

			});

		// L???
		} else {
			topLink.css({
				'display': 'none',
				'position': 'fixed',
				'right': right + 'px',
				'top': (jQuery(window).height() - _self.config.distanceToBottom) + 'px',
	//			'background-image':'url(../images/go_top.gif)',
		    	'background-image':'url(../images/go-top1.png)',
		    	'opacity':'0.6'
			});
		}
	},

	/**
	 * ק`ImMܪA
	 */
	_scrollScreen: function(args) {
		var _self = args._self;

		// `IiJðϰ, ø`I
		var topLink = jQuery('#' + _self.config.nodeId);
		if(jQuery(document).scrollTop() <= _self.config.hideRegionHeight) {
			clearTimeout(_self.cache.topLinkThread);
			topLink.hide();
			return;
		}

		// bðϰ줧~, IE6 ק`Ibm, ܸ`I
		if(/MSIE 6/i.test(navigator.userAgent)) {
			clearTimeout(_self.cache.topLinkThread);
			topLink.hide();

			_self.cache.topLinkThread = setTimeout(function() {
				var top = jQuery(document).scrollTop() + jQuery(window).height() - _self.config.distanceToBottom;
				topLink.css({'top': top + 'px'}).fadeIn();
			}, 400);

		// bðϰ줧~, Lsܸ`I
		} else {
			topLink.fadeIn();
		}
	},

	/**
	 * ק`Im
	 */
	_resizeWindow: function(args) {
		var _self = args._self;

		var topLink = jQuery('#' + _self.config.nodeId);

		// `I̹k䪺Z
		var right = _self._getDistanceToBottom({_self:_self});

		// `I̹Z
		var top = jQuery(window).height() - _self.config.distanceToBottom;
		// IE6 ϥΨ쭶ZN
		if(/MSIE 6/i.test(navigator.userAgent)) {
			top += jQuery(document).scrollTop();
		}

		// wq`Im
		topLink.css({
			'right': right + 'px',
			'top': top + 'px'
		});
	},

	/**
	 * `I̹k䪺Z
	 */
	_getDistanceToBottom: function(args) {
		var _self = args._self;

		// `I̹k䪺Z= (̹e- e+ 1 "B1px Ω" ) / 2 - `Ie- `I쭶k䪺e(20px), pGkZ̹ɤp10px
		var right = parseInt((jQuery(window).width() - _self.config.pageWidth + 1)/2 - _self.config.nodeWidth - _self.config.distanceToPage, 10);
		if(right < 10) {
			right = 10;
		}

		return right;
	}
};